SystemOrganization addCategory: 'OrbeonBizagiReader2_Tests'!

TestCase subclass: #XPDLReader2Test2
	instanceVariableNames: 'reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2_Tests'!

!XPDLReader2Test2 methodsFor: 'test proc 2 activities' stamp: 'BrunoBB 10/25/2015 15:15'!
activitiesNames2Test
	| taskNames |

	taskNames := #('analyze-issue' 'report-fixes' 'internal-test').

	self assert: (self getFixIssueProcess getTaskNodes allSatisfy: [:each | taskNames includes: each getName]).

	self assert: (self getFixIssueProcess getTaskNodes size = taskNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 3 activities' stamp: 'BrunoBB 10/25/2015 16:21'!
activitiesNames3Test
	| taskNames |

	taskNames := #('analyze-developer-report' 'report-workaround' 'report-solution').

	self assert: (self getReportToArchitectProcess getTaskNodes allSatisfy: [:each | taskNames includes: each getName]).

	self assert: (self getReportToArchitectProcess getTaskNodes size = taskNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 activities' stamp: 'BrunoBB 10/25/2015 14:41'!
activitiesNamesTest
	| taskNames |

	taskNames := #('test-case' 'execute-test' 'test-ok' 'analyze-issue-report').

	self assert: (self getTestCaseProcess getTaskNodes allSatisfy: [:each | taskNames includes: each getName]).

	self assert: (self getTestCaseProcess getTaskNodes size = taskNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 activities' stamp: 'BrunoBB 10/25/2015 15:17'!
gatewaysNames2Test
	| gatewaysNames |

	gatewaysNames := #('can fix').

	self assert: (self getFixIssueProcess getGatewayNodes allSatisfy: [:each | gatewaysNames includes: each getName]).

	self assert: (self getFixIssueProcess getGatewayNodes size = gatewaysNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 3 activities' stamp: 'BrunoBB 10/25/2015 16:21'!
gatewaysNames3Test
	| gatewaysNames |

	gatewaysNames := #('has-solution').

	self assert: (self getReportToArchitectProcess getGatewayNodes allSatisfy: [:each | gatewaysNames includes: each getName]).

	self assert: (self getReportToArchitectProcess getGatewayNodes size = gatewaysNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 activities' stamp: 'BrunoBB 10/25/2015 15:03'!
gatewaysNamesTest
	| gatewaysNames |

	gatewaysNames := #('is-issue' 'accept-issue').

	self assert: (self getTestCaseProcess getGatewayNodes allSatisfy: [:each | gatewaysNames includes: each getName]).

	self assert: (self getTestCaseProcess getGatewayNodes size = gatewaysNames size).! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 14:42'!
getFixIssueProcess

	^reader getProcessNamed: 'FixIssue' ifNone: [self assert: false]! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 14:43'!
getReportToArchitectProcess

	^reader getProcessNamed: 'ReportToArchitect' ifNone: [self assert: false]! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 14:42'!
getTestCaseProcess

	^reader getProcessNamed: 'TestCase' ifNone: [self assert: false]! !

!XPDLReader2Test2 methodsFor: 'test proc 2 inout transitions' stamp: 'BrunoBB 10/25/2015 15:57'!
inTransitions2Test
	| process transition task1 gateway |

	process := self getFixIssueProcess.

	task1 := process getTaskNamed: 'analyze-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-analyze' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-fix' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'report-fixes' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-report' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getSubprocessNamed: 'report-to-architect' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'no-fix-report' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'internal-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'do-internal-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'architect-done' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'finish-internal-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).! !

!XPDLReader2Test2 methodsFor: 'test proc 3 inout transitions' stamp: 'BrunoBB 10/25/2015 16:37'!
inTransitions3Test
	| process transition task1 gateway |

	process := self getReportToArchitectProcess.

	task1 := process getTaskNamed: 'analyze-developer-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-dev-analysis' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-a-solution' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'report-workaround' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-workaround' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'report-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-solution' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-solution' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-workaround' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 inout transitions' stamp: 'BrunoBB 10/25/2015 15:03'!
inTransitionsTest
	| process transition task1 gateway |

	process := self getTestCaseProcess.

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-case' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getTaskNamed: 'execute-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'run-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-issue' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'test-ok' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-ok' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'report-issue' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-report' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'reject-issue' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-finished' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getSubprocessNamed: 'fix-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'fix' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-again' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 lanes' stamp: 'BrunoBB 10/25/2015 15:41'!
objectsInLanes2Test
	| process lane1 |

	process := self getFixIssueProcess.

	lane1 := process getLaneNamed: 'developer' ifNone: [self assert: false].

	self assert: ((lane1 getAnyObjectNamed: 'start' ifNone: [self assert: false]) == process startNode).

	self assert: ((lane1 getAnyObjectNamed: 'analyze-issue' ifNone: [self assert: false]) == (process getTaskNamed: 'analyze-issue' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'can fix' ifNone: [self assert: false]) == (process getGatewayNamed: 'can fix' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'report-fixes' ifNone: [self assert: false]) == (process getTaskNamed: 'report-fixes' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'internal-test' ifNone: [self assert: false]) == (process getTaskNamed: 'internal-test' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'report-to-architect' ifNone: [self assert: false]) == (process getSubprocessNamed: 'report-to-architect' ifNone: [self assert: false])).! !

!XPDLReader2Test2 methodsFor: 'test proc 3 lanes' stamp: 'BrunoBB 10/25/2015 16:30'!
objectsInLanes3Test
	| process lane1 |

	process := self getReportToArchitectProcess.

	lane1 := process getLaneNamed: 'architect' ifNone: [self assert: false].

	self assert: ((lane1 getAnyObjectNamed: 'start' ifNone: [self assert: false]) == process startNode).

	self assert: ((lane1 getAnyObjectNamed: 'analyze-developer-report' ifNone: [self assert: false]) == (process getTaskNamed: 'analyze-developer-report' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'has-solution' ifNone: [self assert: false]) == (process getGatewayNamed: 'has-solution' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'report-workaround' ifNone: [self assert: false]) == (process getTaskNamed: 'report-workaround' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'report-solution' ifNone: [self assert: false]) == (process getTaskNamed: 'report-solution' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'end' ifNone: [self assert: false]) == (process getEndNodeNamed: 'end' ifNone: [self assert: false])).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 lanes' stamp: 'BrunoBB 10/25/2015 15:04'!
objectsInLanesTest
	| process lane1 lane2 lane3 |

	process := self getTestCaseProcess.

	lane1 := process getLaneNamed: 'developer' ifNone: [self assert: false].
	lane2 := process getLaneNamed: 'test-expert' ifNone: [self assert: false].
	lane3 := process getLaneNamed: 'tester' ifNone: [self assert: false].

	self assert: ((lane1 getAnyObjectNamed: 'fix-issue' ifNone: [self assert: false]) == (process getSubprocessNamed: 'fix-issue' ifNone: [self assert: false])).

	self assert: ((lane2 getAnyObjectNamed: 'start' ifNone: [self assert: false]) == process startNode).

	self assert: ((lane2 getAnyObjectNamed: 'analyze-issue-report' ifNone: [self assert: false]) == (process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false])).

	self assert: ((lane2 getAnyObjectNamed: 'accept-issue' ifNone: [self assert: false]) == (process getGatewayNamed: 'accept-issue' ifNone: [self assert: false])).

	self assert: ((lane2 getAnyObjectNamed: 'end' ifNone: [self assert: false]) == (process getEndNodeNamed: 'end' ifNone: [self assert: false])).

	self assert: ((lane3 getAnyObjectNamed: 'execute-test' ifNone: [self assert: false]) == (process getTaskNamed: 'execute-test' ifNone: [self assert: false])).

	self assert: ((lane3 getAnyObjectNamed: 'is-issue' ifNone: [self assert: false]) == (process getGatewayNamed: 'is-issue' ifNone: [self assert: false])).

	self assert: ((lane3 getAnyObjectNamed: 'test-ok' ifNone: [self assert: false]) == (process getTaskNamed: 'test-ok' ifNone: [self assert: false])).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 inout transitions' stamp: 'BrunoBB 10/25/2015 16:18'!
outTransitions2Test
	| process transition task1 gateway |

	process := self getFixIssueProcess.
	transition := process getTransitionNamed: 'start-analyze' ifNone: [self assert: false].
	self assert: (process startNode outTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-fix' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-report' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'no-fix-report' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	task1 := process getTaskNamed: 'report-fixes' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'do-internal-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getSubprocessNamed: 'report-to-architect' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'architect-done' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'internal-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'finish-internal-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!XPDLReader2Test2 methodsFor: 'test proc 3 inout transitions' stamp: 'BrunoBB 10/25/2015 16:46'!
outTransitions3Test
	| process transition task1 gateway |

	process := self getReportToArchitectProcess.
	transition := process getTransitionNamed: 'start-dev-analysis' ifNone: [self assert: false].
	self assert: (process startNode outTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-developer-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-a-solution' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-workaround' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-solution' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	task1 := process getTaskNamed: 'report-workaround' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-workaround' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'report-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-solution' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 inout transitions' stamp: 'BrunoBB 10/25/2015 15:04'!
outTransitionsTest
	| process transition task1 gateway |

	process := self getTestCaseProcess.
	transition := process getTransitionNamed: 'start-case' ifNone: [self assert: false].
	self assert: (process startNode outTransitions last == transition).

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'run-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'execute-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-issue' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-ok' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'report-issue' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	task1 := process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-report' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'reject-issue' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'fix' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	task1 := process getSubprocessNamed: 'fix-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-again' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 16:59'!
setUp

	reader := XPDLReader2 for: 'TestCase' withString: XPDLProcessTemplate xpdlExample_ProcessTestCase.
	reader addProcessNamed: 'FixIssue' parsedAs: (XMLDOMParser parse: XPDLProcessTemplate xpdlExample_ProcessFixIssue).
	reader addProcessNamed: 'ReportToArchitect' parsedAs: (XMLDOMParser parse: XPDLProcessTemplate xpdlExample_ProcessReportToArchitect).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 activities' stamp: 'BrunoBB 10/25/2015 15:17'!
subProcessNames2Test
	| subprocessesNames |

	subprocessesNames := #('report-to-architect').

	self assert: (self getFixIssueProcess getSubProcessNodes allSatisfy: [:each | subprocessesNames includes: each getName]).

	self assert: (self getFixIssueProcess getSubProcessNodes size = subprocessesNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 activities' stamp: 'BrunoBB 10/25/2015 15:04'!
subProcessNamesTest
	| subprocessesNames |

	subprocessesNames := #('fix-issue').

	self assert: (self getTestCaseProcess getSubProcessNodes allSatisfy: [:each | subprocessesNames includes: each getName]).

	self assert: (self getTestCaseProcess getSubProcessNodes size = subprocessesNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 conditions' stamp: 'BrunoBB 10/25/2015 15:21'!
transitionCreateReportConditionsTest
	| process transition |

	process := self getFixIssueProcess.
	transition := process transitions detect: [:each | each endNode == (process getTaskNamed: 'report-fixes' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form developerCanFix = ''yes'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 3 conditions' stamp: 'BrunoBB 10/25/2015 16:25'!
transitionCreateSolutionConditionsTest
	| process transition |

	process := self getReportToArchitectProcess.

	transition := process transitions detect: [:each | each endNode == (process getTaskNamed: 'report-solution' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form hasSolution = ''yes'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 3 conditions' stamp: 'BrunoBB 10/25/2015 16:26'!
transitionCreateWorkaroundConditionsTest
	| process transition |

	process := self getReportToArchitectProcess.

	transition := process transitions detect: [:each | each endNode == (process getTaskNamed: 'report-workaround' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form hasSolution = ''no'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 1 conditions' stamp: 'BrunoBB 10/25/2015 15:04'!
transitionFixIssueConditionsTest
	| process transition |

	process := self getTestCaseProcess.
	transition := process transitions detect: [:each | each endNode == (process getSubprocessNamed: 'fix-issue' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form acceptOrReject = ''accept'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 2 conditions' stamp: 'BrunoBB 10/25/2015 16:24'!
transitionNoFixReportConditionsTest
	| process transition |

	process := self getFixIssueProcess.
	transition := process transitions detect: [:each | each endNode == (process getSubprocessNamed: 'report-to-architect' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form developerCanFix = ''no'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 1 conditions' stamp: 'BrunoBB 10/25/2015 15:04'!
transitionRejectIssueConditionsTest
	| process transition |

	process := self getTestCaseProcess.
	transition := process transitions detect: [:each | (each endNode == (process getEndNodeNamed: 'end' ifNone: [self assert: false]))
		and: [each startNode isGatewayNode]
	].

	self assert: (transition startCondition = '[:form | form acceptOrReject = ''reject'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 1 conditions' stamp: 'BrunoBB 10/25/2015 15:04'!
transitionReportIssueConditionsTest
	| process transition |

	process := self getTestCaseProcess.
	transition := process transitions detect: [:each | each endNode == (process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form result = ''failed'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 1 conditions' stamp: 'BrunoBB 10/25/2015 15:04'!
transitionTestOkConditionsTest
	| process transition |

	process := self getTestCaseProcess.
	transition := process transitions detect: [:each | each endNode == (process getTaskNamed: 'test-ok' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form result ~= ''failed'']')! !
